module.exports =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 7);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.isStringEmpty = isStringEmpty;
exports.guid = guid;
var RUNTIME_TYPE = exports.RUNTIME_TYPE = {
    'UNKNOWN': 0, // 未知
    'BROWSER': 1, //浏览器
    'WX_APP': 2 //微信小程序
};

var runtime = RUNTIME_TYPE.UNKNOWN;
var platform = 'unknown';

if (typeof window !== 'undefined') {
    runtime = RUNTIME_TYPE.BROWSER;
    platform = 'web';
} else {
    if (typeof wx !== 'undefined') {
        runtime = RUNTIME_TYPE.WX_APP;
        platform = 'wx_app';
    }
}

var RUNTIME = exports.RUNTIME = runtime;
var PLATFORM = exports.PLATFORM = platform;

function isStringEmpty(string) {
    return typeof string !== 'string' || string.trim() === '';
}

function guid() {
    function s4() {
        return Math.floor((1 + Math.random()) * 0x10000).toString(16).substring(1);
    }

    return s4() + s4() + '-' + s4() + '-' + s4() + '-' + s4() + '-' + s4() + s4() + s4();
}

/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.getItem = getItem;
exports.setItem = setItem;

var _Utils = __webpack_require__(0);

var Utils = _interopRequireWildcard(_Utils);

var _IStorage = __webpack_require__(3);

var _IStorage2 = _interopRequireDefault(_IStorage);

var _BrowserStorage = __webpack_require__(10);

var _BrowserStorage2 = _interopRequireDefault(_BrowserStorage);

var _WXAppStorage = __webpack_require__(11);

var _WXAppStorage2 = _interopRequireDefault(_WXAppStorage);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

var storage = new _IStorage2.default();

if (Utils.RUNTIME === Utils.RUNTIME_TYPE.BROWSER) {
    storage = new _BrowserStorage2.default();
} else if (Utils.RUNTIME === Utils.RUNTIME_TYPE.WX_APP) {
    storage = new _WXAppStorage2.default();
} else {
    console.error("unknown runtime, storage not support");
}

function getItem(key) {
    return storage.getItem(key);
}

function setItem(key, value) {
    storage.setItem(key, value);
}

/***/ }),
/* 2 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.setAppKey = setAppKey;
exports.getAppKey = getAppKey;
exports.isAppKeyValid = isAppKeyValid;
exports.setVersion = setVersion;
exports.getVersion = getVersion;
var _appKey = "";
var _version = "";

function setAppKey(appKey) {
    _appKey = appKey;
}

function getAppKey() {
    return _appKey;
}

function isAppKeyValid() {
    return _appKey !== undefined && _appKey !== null && typeof _appKey === "string" && _appKey.length > 0;
}

function setVersion(version) {
    _version = version;
}

function getVersion() {
    return _version;
}

/***/ }),
/* 3 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var IStorage = function () {
    function IStorage() {
        _classCallCheck(this, IStorage);
    }

    _createClass(IStorage, [{
        key: "setItem",
        value: function setItem(key, value) {}
    }, {
        key: "getItem",
        value: function getItem(key) {}
    }]);

    return IStorage;
}();

exports.default = IStorage;

/***/ }),
/* 4 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _LocalData = __webpack_require__(1);

var LocalData = _interopRequireWildcard(_LocalData);

var _Utils = __webpack_require__(0);

var utils = _interopRequireWildcard(_Utils);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var g_instance = null;

var UserProperty = function () {
    function UserProperty() {
        _classCallCheck(this, UserProperty);

        var str = LocalData.getItem("properties");
        this.user_properties = {};
        if (!utils.isStringEmpty(str)) {
            this.user_properties = JSON.parse(str);
        }
    }

    _createClass(UserProperty, [{
        key: 'setProperties',
        value: function setProperties(properties) {
            for (var key in properties) {
                if (properties.hasOwnProperty(key)) {
                    this.user_properties[key] = properties[key];
                }
            }

            LocalData.setItem("properties", JSON.stringify(this.user_properties));
        }
    }, {
        key: 'getProperties',
        value: function getProperties() {
            return this.user_properties;
        }
    }], [{
        key: 'getInstance',
        value: function getInstance() {
            if (g_instance === null) {
                g_instance = new UserProperty();
            }
            return g_instance;
        }
    }]);

    return UserProperty;
}();

exports.default = UserProperty;

/***/ }),
/* 5 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.send = send;

var _Utils = __webpack_require__(0);

var Utils = _interopRequireWildcard(_Utils);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

/**
 * @param url
 * @param data
 * @param onSuccess
 * @param onError
 */
function send(url, data, onSuccess, onError) {
    if (Utils.RUNTIME === Utils.RUNTIME_TYPE.BROWSER) {
        var xmlHttpRequest = new XMLHttpRequest();
        xmlHttpRequest.onreadystatechange = function () {
            if (xmlHttpRequest.readyState === 4) {
                if (xmlHttpRequest.status === 200) {
                    if (typeof onSuccess === "function") {
                        onSuccess(xmlHttpRequest.responseText);
                    }
                } else {
                    if (typeof onError === "function") {
                        onError();
                    }
                }
            }
        };

        xmlHttpRequest.open("POST", url, true);
        xmlHttpRequest.send(JSON.stringify(data));
    } else if (Utils.RUNTIME === Utils.RUNTIME_TYPE.WX_APP) {
        wx.request({
            url: url,
            data: data,
            method: 'POST',
            header: { 'content-type': 'application/json' },
            success: function success(res) {
                if (typeof onSuccess === 'function') {
                    onSuccess(JSON.stringify(res.data));
                }
            },
            fail: function fail() {
                if (typeof onError === "function") {
                    onError();
                }
            }
        });
    } else {
        console.error("unsupported platform");
    }
}

/***/ }),
/* 6 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
  value: true
});

var _config = __webpack_require__(14);

var _config2 = _interopRequireDefault(_config);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = _config2.default;

/***/ }),
/* 7 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

exports.init = init;
exports.setAutoPageView = setAutoPageView;
exports.trackPageView = trackPageView;
exports.trackEvent = trackEvent;
exports.sendEvent = sendEvent;
exports.setLogHandler = setLogHandler;
exports.actionTimeStart = actionTimeStart;
exports.actionTimeEnd = actionTimeEnd;
exports.setUserId = setUserId;
exports.setChannel = setChannel;
exports.setUserProperties = setUserProperties;
exports.setVersion = setVersion;
exports.recActionExpose = recActionExpose;
exports.recActionView = recActionView;
exports.recActionTransact = recActionTransact;
exports.recActionCollect = recActionCollect;
exports.recActionUncollect = recActionUncollect;
exports.recActionLike = recActionLike;
exports.recActionDislike = recActionDislike;

var _app = __webpack_require__(8);

var _app2 = _interopRequireDefault(_app);

var _Config = __webpack_require__(2);

var Config = _interopRequireWildcard(_Config);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var app = new _app2.default();

app.start();

function init(appKey) {
    Config.setAppKey(appKey);
}

function setAutoPageView(autoPageView) {
    app.pushAction('setAutoPageView', autoPageView);
}

function trackPageView(url, referrer) {
    app.pushAction('trackPageView', url, referrer);
}

function trackEvent(category, action, label, value) {
    app.pushAction('trackEvent', category, action, label, value);
}

function sendEvent(eventId, params) {
    app.pushAction('sendEvent', eventId, params);
}

function setLogHandler(logHandler) {
    app.pushAction('setLogHandler', logHandler);
}

function actionTimeStart(action, extdata) {
    app.pushAction('actionTimeStart', action, extdata);
}

function actionTimeEnd(action) {
    app.pushAction('actionTimeEnd', action);
}

function setUserId(userId) {
    app.pushAction('setUserId', userId);
}

function setChannel(channel) {
    app.pushAction('setChannel', channel);
}

function setUserProperties(properties) {
    app.pushAction('setUserProperties', properties);
}

function setVersion(version) {
    app.pushAction('setVersion', version);
}

function push_action_with_items(action, itemOrArray) {
    var items = void 0;
    if ((typeof itemOrArray === 'undefined' ? 'undefined' : _typeof(itemOrArray)) === 'object') {
        items = itemOrArray;
    } else {
        items = [itemOrArray];
    }

    for (var i = 0; i < items.length; i++) {
        app.pushAction(action, items[i]);
    }
}

function recActionExpose(item) {
    push_action_with_items('recActionExpose', item);
}

function recActionView(item) {
    push_action_with_items('recActionView', item);
}

function recActionTransact(item) {
    push_action_with_items('recActionTransact', item);
}

function recActionCollect(item) {
    push_action_with_items('recActionCollect', item);
}

function recActionUncollect(item) {
    push_action_with_items('recActionUncollect', item);
}

function recActionLike(item) {
    push_action_with_items('recActionLike', item);
}

function recActionDislike(item) {
    push_action_with_items('recActionDislike', item);
}

/***/ }),
/* 8 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Config = __webpack_require__(2);

var Config = _interopRequireWildcard(_Config);

var _Server = __webpack_require__(9);

var Server = _interopRequireWildcard(_Server);

var _Log = __webpack_require__(19);

var _Log2 = _interopRequireDefault(_Log);

var _UserProperty = __webpack_require__(4);

var _UserProperty2 = _interopRequireDefault(_UserProperty);

var _LocalData = __webpack_require__(1);

var LocalData = _interopRequireWildcard(_LocalData);

var _Utils = __webpack_require__(0);

var Utils = _interopRequireWildcard(_Utils);

var _ActionQueue = __webpack_require__(20);

var _ActionQueue2 = _interopRequireDefault(_ActionQueue);

var _Const = __webpack_require__(21);

var _Const2 = _interopRequireDefault(_Const);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var PRE_INIT_ACTIONS = ['setAppKey', 'setAutoPageView'];
var g_instance = null;

var App = function () {
    function App() {
        _classCallCheck(this, App);

        this._autoPageView = true;
        this._actionQueue = new _ActionQueue2.default();
    }

    _createClass(App, [{
        key: "start",
        value: function start() {
            this._processFunctionCall();

            if (this._autoPageView) {
                this.pushAction('trackPageView');
            }

            this._loop();
        }
    }, {
        key: "pushAction",
        value: function pushAction(actionName) {
            for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
                args[_key - 1] = arguments[_key];
            }

            this._actionQueue.push([actionName].concat(args));
        }
    }, {
        key: "_loop",
        value: function _loop() {

            this._processFunctionCall();

            var self = this;

            setTimeout(function () {
                self._loop();
            }, 50);
        }
    }, {
        key: "_processFunctionCall",
        value: function _processFunctionCall() {
            var actions = void 0;
            if (!Config.isAppKeyValid()) {
                actions = this._actionQueue.popAllMatchTypes(PRE_INIT_ACTIONS);
            } else {
                actions = this._actionQueue.popAll();
            }
            while (actions.length > 0) {
                /**
                 * @type {Array}
                 */
                var item = actions.shift();
                var functionName = item[0];
                var _args = item.slice(1);

                if (this[functionName] !== undefined) {
                    var f = this[functionName];
                    f.apply(this, _args);
                } else {
                    console.warn("function not exist:" + functionName + " for" + item.join(","));
                }
            }
        }
    }, {
        key: "setAppKey",
        value: function setAppKey(appKey) {
            Config.setAppKey(appKey);
        }
    }, {
        key: "setAutoPageView",


        /**
         * @param autoPageView bool
         */
        value: function setAutoPageView(autoPageView) {
            this._autoPageView = autoPageView;
        }
    }, {
        key: "trackPageView",


        /**
         * @param url
         * @param referrer
         */
        value: function trackPageView(url, referrer) {
            if (Utils.RUNTIME === Utils.RUNTIME_TYPE.BROWSER) {
                url = url || window.location.href;
                referrer = referrer || document.referrer;
            }

            Server.sendPV(url, referrer);
        }
    }, {
        key: "trackEvent",
        value: function trackEvent(category, action, label, value) {
            Server.sendAction(category, action, label, value);
        }
    }, {
        key: "sendEvent",
        value: function sendEvent(eventId, params) {
            Server.sendEvent(eventId, params);
        }
    }, {
        key: "setLogHandler",
        value: function setLogHandler(logHandler) {
            _Log2.default.getInstance().setLogHandler(logHandler);
        }
    }, {
        key: "addLog",
        value: function addLog(content) {
            _Log2.default.getInstance().add(content);
        }
    }, {
        key: "actionTimeStart",
        value: function actionTimeStart(action, extdata) {
            Server.actionTimeStart("custom", action, extdata);
        }
    }, {
        key: "actionTimeEnd",
        value: function actionTimeEnd(action) {
            Server.actionTimeEnd(action);
        }
    }, {
        key: "setUserId",
        value: function setUserId(userId) {
            LocalData.setItem("user_id", userId);
        }
    }, {
        key: "setChannel",
        value: function setChannel(channel) {
            LocalData.setItem("channel", channel);
        }
    }, {
        key: "setOChannel",
        value: function setOChannel(o_channel) {
            LocalData.setItem("o_channel", o_channel);
        }
    }, {
        key: "setUserProperties",
        value: function setUserProperties(properties) {
            _UserProperty2.default.getInstance().setProperties(properties);
        }
    }, {
        key: "setVersion",
        value: function setVersion(version) {
            LocalData.setItem("version", version);
        }
    }, {
        key: "recActionExpose",
        value: function recActionExpose(item) {
            Server.sendRecommendAction(_Const2.default.RECOMMEND_ACTION_EXPOSE, item, 1);
        }
    }, {
        key: "recActionView",
        value: function recActionView(item) {
            Server.sendRecommendAction(_Const2.default.RECOMMEND_ACTION_VIEW, item, 1);
        }
    }, {
        key: "recActionTransact",
        value: function recActionTransact(item) {
            Server.sendRecommendAction(_Const2.default.RECOMMEND_ACTION_TRANSACT, item, 1);
        }
    }, {
        key: "recActionCollect",
        value: function recActionCollect(item) {
            Server.sendRecommendAction(_Const2.default.RECOMMEND_ACTION_COLLECT, item, 1);
        }
    }, {
        key: "recActionUncollect",
        value: function recActionUncollect(item) {
            Server.sendRecommendAction(_Const2.default.RECOMMEND_ACTION_COLLECT, item, 0);
        }
    }, {
        key: "recActionLike",
        value: function recActionLike(item) {
            Server.sendRecommendAction(_Const2.default.RECOMMEND_ACTION_LIKE, item, 1);
        }
    }, {
        key: "recActionDislike",
        value: function recActionDislike(item) {
            Server.sendRecommendAction(_Const2.default.RECOMMEND_ACTION_LIKE, item, 0);
        }
    }], [{
        key: "getInstance",
        value: function getInstance() {
            if (g_instance === null) {
                g_instance = new App();
            }
            return g_instance;
        }
    }]);

    return App;
}();

exports.default = App;

/***/ }),
/* 9 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.sendPV = sendPV;
exports.sendRecommendUserAction = sendRecommendUserAction;
exports.sendAction = sendAction;
exports.sendEvent = sendEvent;
exports.actionTimeStart = actionTimeStart;
exports.actionTimeEnd = actionTimeEnd;
exports.sendRecommendAction = sendRecommendAction;

var _LocalData = __webpack_require__(1);

var LocalData = _interopRequireWildcard(_LocalData);

var _UserProperty = __webpack_require__(4);

var _UserProperty2 = _interopRequireDefault(_UserProperty);

var _Config = __webpack_require__(2);

var Config = _interopRequireWildcard(_Config);

var _Net = __webpack_require__(5);

var Net = _interopRequireWildcard(_Net);

var _EventSender = __webpack_require__(12);

var EventSender = _interopRequireWildcard(_EventSender);

var _ActionTime = __webpack_require__(15);

var _ActionTime2 = _interopRequireDefault(_ActionTime);

var _EventId = __webpack_require__(16);

var EventId = _interopRequireWildcard(_EventId);

var _Utils = __webpack_require__(0);

var Utils = _interopRequireWildcard(_Utils);

var _DeviceId = __webpack_require__(17);

var DeviceId = _interopRequireWildcard(_DeviceId);

var _BuildConfig = __webpack_require__(6);

var _BuildConfig2 = _interopRequireDefault(_BuildConfig);

var _Session = __webpack_require__(18);

var Session = _interopRequireWildcard(_Session);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

var USER_ID_KEY = "user_id";

function processDeviceId(result) {
    try {
        var result_obj = JSON.parse(result);
        var uid = result_obj["uid"];
        if (!Utils.isStringEmpty(uid)) {
            DeviceId.setDeviceId(uid);
        }
    } catch (e) {
        console.error(e);
    }
}

function appendDeviceId(data) {
    var uid = DeviceId.getDeviceId();

    data["uid"] = uid;
    data["device_id"] = uid;
}

function appendVersionInfo(data) {
    data["version"] = Config.getVersion();
}

function appendInfo(data) {
    data["id"] = EventId.next();
    data["time"] = new Date().getTime();
    data['platform'] = Utils.PLATFORM;
}

function appendUserInfo(data) {
    data["user_properties"] = _UserProperty2.default.getInstance().getProperties();
    var channel = LocalData.getItem("channel");
    if (channel === null) {
        channel = "";
    }
    var userId = LocalData.getItem(USER_ID_KEY);
    if (userId === null) {
        userId = "";
    }

    var version = LocalData.getItem("version");
    if (version === null) {
        version = "";
    }

    var o_channel = LocalData.getItem("o_channel");
    if (o_channel === null) {
        o_channel = "";
    }

    data["channel"] = channel;
    data["user_id"] = userId;
    data["version"] = version;
    data["sdk_version"] = _BuildConfig2.default.SDK_VERSION;
    data["o_channel"] = o_channel;
}

function sendPV(url, referrer) {
    var data = { appkey: Config.getAppKey(), url: url, referrer: referrer };

    appendDeviceId(data);

    appendVersionInfo(data);

    appendInfo(data);

    appendUserInfo(data);

    Net.send(_BuildConfig2.default.SERVER + "/api/web/pv", data, function (result) {
        processDeviceId(result);
    }, null);
}

function sendRecommendUserAction(actionData) {
    var data = _extends({ appkey: Config.getAppKey() }, actionData);
    // const data= {};

    appendInfo(data);
    appendUserInfo(data);
    EventSender.recommendEvent.send(data);
}

function sendAction(category, action, label, value) {
    var data = { appkey: Config.getAppKey(), category: category, action: action, label: label, value: value };

    appendDeviceId(data);

    appendVersionInfo(data);

    appendInfo(data);

    appendUserInfo(data);

    EventSender.userEvent.send(data);
}

function sendEvent(eventId, params) {
    var data = { appkey: Config.getAppKey(), action: eventId, params: params };

    appendDeviceId(data);

    appendVersionInfo(data);

    appendInfo(data);

    appendUserInfo(data);

    EventSender.userEvent.send(data);
}

function actionTimeStart(type, action, extdata) {
    var data = { app_id: Config.getAppKey(), type: type, event_id: action, params: extdata };

    appendDeviceId(data);

    appendVersionInfo(data);

    appendInfo(data);

    appendUserInfo(data);

    var actionTime = _ActionTime2.default.getInstance(_BuildConfig2.default.WS_SERVER);

    actionTime.start(data);
}

function actionTimeEnd(action) {
    var data = { event_id: action };

    var actionTime = _ActionTime2.default.getInstance(_BuildConfig2.default.WS_SERVER);

    actionTime.end(data);
}

function sendRecommendAction(action, item, weight) {
    var user_id = LocalData.getItem(USER_ID_KEY);
    if (Utils.isStringEmpty(user_id)) {
        user_id = "";
    }

    EventSender.recommendEvent.send({
        app_id: Config.getAppKey(),
        user_id: user_id,
        item_id: item,
        act_type: action,
        session_id: Session.getId(),
        weight: weight,
        time: new Date().getTime()
    });
}

/***/ }),
/* 10 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _IStorage2 = __webpack_require__(3);

var _IStorage3 = _interopRequireDefault(_IStorage2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function localStorageGetItem(key) {
    if (!window.localStorage) {
        return "";
    }

    return window.localStorage.getItem(key);
}

function localStorageSetItem(key, value) {
    if (!window.localStorage) {
        return;
    }

    window.localStorage.setItem(key, value);
}

function setCookie(name, value, expiredays) {
    var ex_data = new Date();
    ex_data.setDate(ex_data.getDate() + expiredays);
    //noinspection JSDeprecatedSymbols
    document.cookie = name + "=" + escape(value) + (expiredays === null ? "" : ";expires=" + ex_data.toUTCString());
}

function getCookie(cookieName) {
    var strCookie = document.cookie;
    var arrCookie = strCookie.split("; ");
    for (var i = 0; i < arrCookie.length; i++) {
        var arr = arrCookie[i].split("=");
        if (cookieName === arr[0]) {
            return unescape(arr[1]);
        }
    }
    return "";
}

var BrowserStorage = function (_IStorage) {
    _inherits(BrowserStorage, _IStorage);

    function BrowserStorage() {
        _classCallCheck(this, BrowserStorage);

        return _possibleConstructorReturn(this, (BrowserStorage.__proto__ || Object.getPrototypeOf(BrowserStorage)).apply(this, arguments));
    }

    _createClass(BrowserStorage, [{
        key: "getItem",
        value: function getItem(key) {
            var value = localStorageGetItem(key);
            if (value !== null && value !== "") {
                return value;
            }

            return getCookie(key);
        }
    }, {
        key: "setItem",
        value: function setItem(key, value) {
            localStorageSetItem(key, value);
            setCookie(key, value, 365);
        }
    }]);

    return BrowserStorage;
}(_IStorage3.default);

exports.default = BrowserStorage;

/***/ }),
/* 11 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _IStorage2 = __webpack_require__(3);

var _IStorage3 = _interopRequireDefault(_IStorage2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var WXAppStorage = function (_IStorage) {
    _inherits(WXAppStorage, _IStorage);

    function WXAppStorage() {
        _classCallCheck(this, WXAppStorage);

        return _possibleConstructorReturn(this, (WXAppStorage.__proto__ || Object.getPrototypeOf(WXAppStorage)).apply(this, arguments));
    }

    _createClass(WXAppStorage, [{
        key: 'getItem',
        value: function getItem(key) {
            return wx.getStorageSync(key);
        }
    }, {
        key: 'setItem',
        value: function setItem(key, value) {
            wx.setStorageSync(key, value);
        }
    }]);

    return WXAppStorage;
}(_IStorage3.default);

exports.default = WXAppStorage;

/***/ }),
/* 12 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.recommendEvent = exports.userEvent = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _EventStorage = __webpack_require__(13);

var EventStorage = _interopRequireWildcard(_EventStorage);

var _Net = __webpack_require__(5);

var Net = _interopRequireWildcard(_Net);

var _Config = __webpack_require__(2);

var Config = _interopRequireWildcard(_Config);

var _BuildConfig = __webpack_require__(6);

var _BuildConfig2 = _interopRequireDefault(_BuildConfig);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var SEND_INTERVAL = 5 * 1000;
var MAX_BATCH_SIZE = 50;

var sending = false;

var allSender = {};

var EventSender = function () {
    function EventSender(type, sender) {
        _classCallCheck(this, EventSender);

        this._type = type;
        this._storage = EventStorage.get(type);
        this._sender = sender;
    }

    _createClass(EventSender, [{
        key: 'send',
        value: function send(data) {
            this._storage.push(data);
        }
    }, {
        key: '_tick',
        value: function _tick(cb) {
            function next() {
                setTimeout(cb, 1);
            }

            var batch_size = Math.min(MAX_BATCH_SIZE, this._storage.length);

            if (batch_size <= 0) {
                return next();
            }

            var batch = this._storage.shift(batch_size);

            var that = this;
            this._sender(batch, function () {
                next();
            }, function () {
                next();
            });
        }
    }]);

    return EventSender;
}();

function start_timer() {
    function timer_tick(cb) {
        var senders = [];
        for (var k in allSender) {
            senders.push(allSender[k]);
        }

        function sender_tick(i) {
            if (i >= senders.length) {
                cb();
                return;
            }

            var sender = senders[i];
            sender._tick(function () {
                sender_tick(i + 1);
            });
        }

        sender_tick(0);
    }

    timer_tick(function () {
        setTimeout(start_timer, SEND_INTERVAL);
    });
}

start_timer();

/**
 * @param type
 * @param sender
 * @returns {EventSender}
 */
function create_sender(type, sender) {
    if (!allSender[type]) {
        allSender[type] = new EventSender(type, sender);
    }

    return allSender[type];
}

/**
 * @type {EventSender}
 */
var userEvent = exports.userEvent = create_sender("user", function (batch, success, fail) {
    Net.send(_BuildConfig2.default.SERVER + "/api/web/event", { "events": batch }, function () {
        success();
    }, function () {
        fail();
    });
});

/**
 * @type {EventSender}
 */
var recommendEvent = exports.recommendEvent = create_sender("rec", function (batch, success, fail) {
    Net.send(_BuildConfig2.default.SERVER + "/api/recommend/event", { "events": batch }, function () {
        success();
    }, function () {
        fail();
    });
});

/***/ }),
/* 13 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.get = get;
exports.push = push;
exports.shift = shift;
exports.getSize = getSize;

var _LocalData = __webpack_require__(1);

var LocalData = _interopRequireWildcard(_LocalData);

var _Utils = __webpack_require__(0);

var Utils = _interopRequireWildcard(_Utils);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var MAX_BUFF_SIZE = 1000;

var dataArray = [];
var saved = false;
var initialized = false;

var allStorage = {};

/**
 *
 * @param type
 * @returns EventStorage
 */
function get(type) {
    if (!allStorage[type]) {
        allStorage[type] = new EventStorage(type, MAX_BUFF_SIZE);
    }

    return allStorage[type];
}

var EventStorage = function () {
    function EventStorage(type, size) {
        _classCallCheck(this, EventStorage);

        this._saved = false;
        this._type = type;
        this._size = size;
        this._dataArray = [];

        var events_str = LocalData.getItem("events-" + this._type);
        if (!Utils.isStringEmpty(events_str)) {
            try {
                this._dataArray = JSON.parse(events_str);
            } catch (e) {
                this._dataArray = [];
            }
        }
    }

    _createClass(EventStorage, [{
        key: 'push',
        value: function push(data) {
            this._dataArray.push(data);

            if (this._dataArray.length > this._size) {
                this._dataArray.shift();
                console.warn("drop off event");
            }

            this._saved = false;
            this._save();
        }
    }, {
        key: 'shift',
        value: function shift(num) {
            num = Math.min(num, this._dataArray.length);
            var ret = this._dataArray.splice(0, num);
            this._saved = false;
            this._save();
            return ret;
        }
    }, {
        key: 'getlength',
        value: function getlength() {
            return this._dataArray.length;
        }
    }, {
        key: '_save',
        value: function _save() {
            var that = this;
            setTimeout(function () {
                if (that._saved) {
                    return;
                }

                LocalData.setItem("events-" + that._type, JSON.stringify(that._dataArray));
                that._saved = true;
            }, 100);
        }
    }]);

    return EventStorage;
}();

function save() {
    setTimeout(function () {
        if (saved) {
            return;
        }
        LocalData.setItem("events", JSON.stringify(dataArray));
        saved = true;
    }, 100);
}

function push(data) {
    get("").push(data);
}

function shift(num) {
    return get("").shift(num);
}

function getSize() {
    return get("").length;
}

/***/ }),
/* 14 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


module.exports = {
   SERVER: "https://cidata-gate2.oneitfarm.com",
   // SERVER: "http://localhost:8081",
   WS_SERVER: "wss://cidata-ws.oneitfarm.com/ws",
   SDK_VERSION: "1.1.2"
};

/***/ }),
/* 15 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Utils = __webpack_require__(0);

var Utils = _interopRequireWildcard(_Utils);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var socket = null;
var isOpen = false;
var instanceId = 0;
var instance = null;
var timeout = null;

var ActionTime = function () {
    function ActionTime(url) {
        _classCallCheck(this, ActionTime);

        try {
            if (!socket) {
                if (Utils.RUNTIME === Utils.RUNTIME_TYPE.WX_APP) {
                    socket = wx.connectSocket({ url: url });
                    socket.onOpen(function (res) {
                        isOpen = true;
                        timeout = setInterval(function () {
                            socket.send({ data: '{"cmd":"action_continue"}' });
                        }, 5000);
                    });
                    socket.onClose(function (res) {
                        clearInterval(timeout);
                    });
                } else {
                    socket = new WebSocket(url);
                    socket.onopen = function () {
                        isOpen = true;
                        timeout = setInterval(function () {
                            socket.send('{"cmd":"action_continue"}');
                        }, 5000);
                    };

                    socket.onclose = function () {
                        clearInterval(timeout);
                    };
                }
            }
        } catch (e) {
            console.warn("不支持WebSocket, 无法精确统计时常");
        }

        this.instanceId = instanceId++;
        this.timeout = null;
    }

    _createClass(ActionTime, [{
        key: 'start',
        value: function start(data) {
            var _this = this;
            if (!isOpen) {
                //处于等待连接成功状态，轮训, 放入时间队列
                setTimeout(function () {
                    _this.start(data);
                }, 300);
            } else {
                if (Utils.RUNTIME === Utils.RUNTIME_TYPE.WX_APP) {
                    socket.send({ data: JSON.stringify({ cmd: 'action_start', params: data }) });
                } else {
                    socket.send(JSON.stringify({ cmd: 'action_start', params: data }));
                }
            }
        }
    }, {
        key: 'end',
        value: function end(data) {
            var _this = this;
            if (!isOpen) {
                //处于等待连接成功状态，轮训, 放入时间队列
                setTimeout(function () {
                    _this.end(data);
                }, 300);
            } else {
                if (Utils.RUNTIME === Utils.RUNTIME_TYPE.WX_APP) {
                    socket.send({ data: JSON.stringify({ cmd: 'action_end', params: data }) });
                } else {
                    socket.send(JSON.stringify({ cmd: 'action_end', params: data }));
                }
            }
        }
    }], [{
        key: 'getInstance',
        value: function getInstance(url) {
            if (instance) {
                return instance;
            }

            instance = new ActionTime(url);

            return instance;
        }
    }]);

    return ActionTime;
}();

exports.default = ActionTime;

/***/ }),
/* 16 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.next = next;

var _LocalData = __webpack_require__(1);

var LocalData = _interopRequireWildcard(_LocalData);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

var current = -1;
var saved = false;

function save() {
    if (saved) {
        return;
    }
    setTimeout(function () {
        LocalData.setItem("last_event_id", current);
        saved = true;
    }, 100);
}

function next() {
    if (current === -1) {
        var val = LocalData.getItem("last_event_id");
        if (val !== null && val !== "") {
            current = val;
        } else {
            current = 0;
        }
    }

    current++;
    saved = false;
    save();
    return current;
}

/***/ }),
/* 17 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.getDeviceId = getDeviceId;
exports.setDeviceId = setDeviceId;

var _LocalData = __webpack_require__(1);

var LocalData = _interopRequireWildcard(_LocalData);

var _Utils = __webpack_require__(0);

var Utils = _interopRequireWildcard(_Utils);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

var DEVICE_ID_KEY = "cidata_uid";

var uid = null;

function guid() {
    function s4() {
        return Math.floor((1 + Math.random()) * 0x10000).toString(16).substring(1);
    }

    return s4() + s4() + '-' + s4() + '-' + s4() + '-' + s4() + '-' + s4() + s4() + s4();
}

function getDeviceId() {
    if (!Utils.isStringEmpty(uid)) {
        return uid;
    }
    uid = LocalData.getItem(DEVICE_ID_KEY);
    if (Utils.isStringEmpty(uid)) {
        uid = guid();
    }
    return uid;
}

function setDeviceId(deviceId) {
    uid = deviceId;
    LocalData.setItem(DEVICE_ID_KEY, deviceId);
}

/***/ }),
/* 18 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.getId = getId;
exports.restart = restart;

var _Utils = __webpack_require__(0);

var Utils = _interopRequireWildcard(_Utils);

var _LocalData = __webpack_require__(1);

var LocalData = _interopRequireWildcard(_LocalData);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

var STORAGE = 'cidata-session';
var SESSION_TIMEOUT = 30 * 60 * 1000;
var SESSION_RENEW_INTERVAL = SESSION_TIMEOUT / 10;

var session = { id: '', time: 0 };

var str = LocalData.getItem(STORAGE);
if (!Utils.isStringEmpty(str)) {
    var s = JSON.parse(str);
    session.id = s.id;
    session.time = s.time;
}

var now = new Date().getTime();
if (now - session.time > SESSION_TIMEOUT) {
    recreate();
}
renew();
save();

setInterval(function () {
    renew();
    save();
}, SESSION_RENEW_INTERVAL);

function save() {
    LocalData.setItem(STORAGE, JSON.stringify(session));
}

function renew() {
    session.time = new Date().getTime();
}

function recreate() {
    session.id = Utils.guid();
}

function getId() {
    return session.id;
}

function restart() {
    recreate();
    renew();
    save();
}

/***/ }),
/* 19 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var g_instance = null;

var Log = function () {
    function Log() {
        _classCallCheck(this, Log);

        this._logHandler = null;
    }

    _createClass(Log, [{
        key: "setLogHandler",
        value: function setLogHandler(handler) {
            this._logHandler = handler;
        }
    }, {
        key: "add",
        value: function add(content) {
            if (this._logHandler !== null) {
                this._logHandler(content);
            } else {
                console.log(content);
            }
        }
    }], [{
        key: "getInstance",
        value: function getInstance() {
            if (g_instance === null) {
                g_instance = new Log();
            }

            return g_instance;
        }
    }]);

    return Log;
}();

exports.default = Log;

/***/ }),
/* 20 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Utils = __webpack_require__(0);

var Utils = _interopRequireWildcard(_Utils);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ActionQueue = function () {
    function ActionQueue() {
        _classCallCheck(this, ActionQueue);

        this._actions = [];
        if (Utils.RUNTIME === Utils.RUNTIME_TYPE.BROWSER) {
            if (typeof window.CIData === 'undefined') {
                window.CIData = [];
            }
            this._actions = window.CIData;
        } else {
            this._actions = [];
        }
    }

    _createClass(ActionQueue, [{
        key: 'push',
        value: function push(action) {
            this._actions.push(action);
        }
    }, {
        key: 'popAll',
        value: function popAll() {
            return this._actions.splice(0, this._actions.length);
        }
    }, {
        key: 'popAllMatchTypes',
        value: function popAllMatchTypes(types) {
            var result = [];
            for (var i = 0; i < this._actions.length; i++) {
                var action = this._actions[i];
                var type = action[0];
                if (types.indexOf(type) !== -1) {
                    result.push(action);
                    this._actions.splice(i, 1);
                    i--;
                }
            }

            return result;
        }
    }]);

    return ActionQueue;
}();

exports.default = ActionQueue;

/***/ }),
/* 21 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});
// const values

exports.default = {

    // 推荐系统user action
    RECOMMEND_ACTION_EXPOSE: 0,
    RECOMMEND_ACTION_VIEW: 1,
    RECOMMEND_ACTION_TRANSACT: 2,
    RECOMMEND_ACTION_COLLECT: 3,
    RECOMMEND_ACTION_LIKE: 4
};

/***/ })
/******/ ]);