let g_instance = null;

export default class Log {

    constructor() {
        this._logHandler = null;
    }

    setLogHandler(handler) {
        this._logHandler = handler;
    }

    add(content) {
        if (this._logHandler !== null) {
            this._logHandler(content);
        }
        else {
            console.log(content);
        }
    };

    static getInstance() {
        if (g_instance === null) {
            g_instance = new Log();
        }

        return g_instance;
    };
}
